--- b/cut-n-paste/synctex/synctex_parser_local.h
+++ a/cut-n-paste/synctex/synctex_parser_local.h
@@ -1,43 +1,43 @@
 /* 
+Copyright (c) 2008, 2009, 2010 , 2011 jerome DOT laurens AT u-bourgogne DOT fr
+
+This file is part of the SyncTeX package.
+
+Latest Revision: Tue Jun 14 08:23:30 UTC 2011
+
+Version: 1.17
+
+See synctex_parser_readme.txt for more details
+
+License:
+--------
+Permission is hereby granted, free of charge, to any person
+obtaining a copy of this software and associated documentation
+files (the "Software"), to deal in the Software without
+restriction, including without limitation the rights to use,
+copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the
+Software is furnished to do so, subject to the following
+conditions:
+
+The above copyright notice and this permission notice shall be
+included in all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+OTHER DEALINGS IN THE SOFTWARE
+
+Except as contained in this notice, the name of the copyright holder  
+shall not be used in advertising or otherwise to promote the sale,  
+use or other dealings in this Software without prior written  
+authorization from the copyright holder.
+
+*/
- Copyright (c) 2008, 2009, 2010 , 2011 jerome DOT laurens AT u-bourgogne DOT fr
- 
- This file is part of the SyncTeX package.
- 
- Latest Revision: Sun Oct 15 15:09:55 UTC 2017
- 
- Version: 1.21
- 
- See synctex_parser_readme.txt for more details
- 
- License:
- --------
- Permission is hereby granted, free of charge, to any person
- obtaining a copy of this software and associated documentation
- files (the "Software"), to deal in the Software without
- restriction, including without limitation the rights to use,
- copy, modify, merge, publish, distribute, sublicense, and/or sell
- copies of the Software, and to permit persons to whom the
- Software is furnished to do so, subject to the following
- conditions:
- 
- The above copyright notice and this permission notice shall be
- included in all copies or substantial portions of the Software.
- 
- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
- OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
- NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
- HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
- OTHER DEALINGS IN THE SOFTWARE
- 
- Except as contained in this notice, the name of the copyright holder
- shall not be used in advertising or otherwise to promote the sale,
- use or other dealings in this Software without prior written
- authorization from the copyright holder.
- 
- */
 
 /* This local header file is for TEXLIVE, use your own header to fit your system */
 #   include <w2c/c-auto.h> /* for inline && HAVE_xxx */
--- b/cut-n-paste/synctex/synctex_parser_utils.c
+++ a/cut-n-paste/synctex/synctex_parser_utils.c
@@ -1,40 +1,41 @@
 /* 
+Copyright (c) 2008, 2009, 2010 , 2011 jerome DOT laurens AT u-bourgogne DOT fr
+
+This file is part of the SyncTeX package.
+
+Latest Revision: Tue Jun 14 08:23:30 UTC 2011
+
+Version: 1.17
+
+See synctex_parser_readme.txt for more details
+
+License:
+--------
+Permission is hereby granted, free of charge, to any person
+obtaining a copy of this software and associated documentation
+files (the "Software"), to deal in the Software without
+restriction, including without limitation the rights to use,
+copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the
+Software is furnished to do so, subject to the following
+conditions:
+
+The above copyright notice and this permission notice shall be
+included in all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+OTHER DEALINGS IN THE SOFTWARE
+
+Except as contained in this notice, the name of the copyright holder  
+shall not be used in advertising or otherwise to promote the sale,  
+use or other dealings in this Software without prior written  
+authorization from the copyright holder.
- Copyright (c) 2008-2017 jerome DOT laurens AT u-bourgogne DOT fr
- 
- This file is part of the __SyncTeX__ package.
- 
- [//]: # (Latest Revision: Fri Jul 14 16:20:41 UTC 2017)
- [//]: # (Version: 1.21)
- 
- See `synctex_parser_readme.md` for more details
- 
- ## License
- 
- Permission is hereby granted, free of charge, to any person
- obtaining a copy of this software and associated documentation
- files (the "Software"), to deal in the Software without
- restriction, including without limitation the rights to use,
- copy, modify, merge, publish, distribute, sublicense, and/or sell
- copies of the Software, and to permit persons to whom the
- Software is furnished to do so, subject to the following
- conditions:
- 
- The above copyright notice and this permission notice shall be
- included in all copies or substantial portions of the Software.
- 
- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
- OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
- NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
- HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
- OTHER DEALINGS IN THE SOFTWARE
- 
- Except as contained in this notice, the name of the copyright holder
- shall not be used in advertising or otherwise to promote the sale,
- use or other dealings in this Software without prior written
- authorization from the copyright holder.
 
 */
 
@@ -60,35 +61,27 @@
 #define SYNCTEX_OS2 1
 #endif
 
+#ifdef _WIN32_WINNT_WINXP
-#if defined(_WIN32)
 #define SYNCTEX_RECENT_WINDOWS 1
 #endif
 
 #ifdef SYNCTEX_WINDOWS
 #include <windows.h>
-#include <shlwapi.h> /* Use shlwapi.lib */
 #endif
 
 void *_synctex_malloc(size_t size) {
+	void * ptr = malloc(size);
+	if(ptr) {
+/*  There used to be a switch to use bzero because it is more secure. JL */
+		memset(ptr,0, size);
+	}
+	return (void *)ptr;
-    void * ptr = malloc(size);
-    if(ptr) {
-        memset(ptr,0, size);/* ensures null termination of strings */
-    }
-    return (void *)ptr;
 }
 
+int _synctex_error(const char * reason,...) {
+	va_list arg;
-void _synctex_free(void * ptr) {
-    if (ptr) {
-        free(ptr);
-    }
-}
-
-#if !defined(_WIN32)
-#   include <syslog.h>
-#endif
-
-int _synctex_log(int level, const char * prompt, const char * reason,va_list arg) {
 	int result;
+	va_start (arg, reason);
 #	ifdef SYNCTEX_RECENT_WINDOWS
 	{/*	This code is contributed by William Blum.
         As it does not work on some older computers,
@@ -100,79 +93,28 @@
         JL.*/
 		char *buff;
 		size_t len;
+		OutputDebugStringA("SyncTeX ERROR: ");
-		OutputDebugStringA(prompt);
 		len = _vscprintf(reason, arg) + 1;
 		buff = (char*)malloc( len * sizeof(char) );
+		result = vsprintf(buff, reason, arg) +strlen("SyncTeX ERROR: ");
-		result = vsprintf(buff, reason, arg) +strlen(prompt);
 		OutputDebugStringA(buff);
 		OutputDebugStringA("\n");
 		free(buff);
 	}
-#   elif SYNCTEX_USE_SYSLOG
-    char * buffer1 = NULL;
-    char * buffer2 = NULL;
-    openlog ("SyncTeX", LOG_CONS | LOG_PID | LOG_PERROR | LOG_NDELAY, LOG_LOCAL0);
-    if (vasprintf(&buffer1,reason,arg)>=0
-        && asprintf(&buffer2,"%s%s",prompt, buffer1)>=0) {
-        syslog (level, "%s", buffer2);
-        result = (int)strlen(buffer2);
-    } else {
-        syslog (level, "%s",prompt);
-        vsyslog(level,reason,arg);
-        result = (int)strlen(prompt);
-    }
-    free(buffer1);
-    free(buffer2);
-    closelog();
 #   else
+	result = fprintf(stderr,"SyncTeX ERROR: ");
+	result += vfprintf(stderr, reason, arg);
+	result += fprintf(stderr,"\n");
-    FILE * where = level == LOG_ERR? stderr: stdout;
-    result = fputs(prompt,where);
-    result += vfprintf(where, reason, arg);
-    result += fprintf(where,"\n");
 #   endif
+	va_end (arg);
 	return result;
 }
 
-int _synctex_error(const char * reason,...) {
-    va_list arg;
-    int result;
-    va_start (arg, reason);
-#if defined(SYNCTEX_RECENT_WINDOWS) /* LOG_ERR is not used */
-    result = _synctex_log(0, "! SyncTeX Error : ", reason, arg);
-#else
-    result = _synctex_log(LOG_ERR, "! SyncTeX Error : ", reason, arg);
-#endif
-    va_end (arg);
-    return result;
-}
-
-int _synctex_debug(const char * reason,...) {
-    va_list arg;
-    int result;
-    va_start (arg, reason);
-#if defined(SYNCTEX_RECENT_WINDOWS) /* LOG_DEBUG is not used */
-    result = _synctex_log(0, "! SyncTeX Error : ", reason, arg);
-#else
-    result = _synctex_log(LOG_DEBUG, "! SyncTeX Error : ", reason, arg);
-#endif
-    va_end (arg);
-    return result;
-}
-
 /*  strip the last extension of the given string, this string is modified! */
 void _synctex_strip_last_path_extension(char * string) {
 	if(NULL != string){
 		char * last_component = NULL;
 		char * last_extension = NULL;
-#       if defined(SYNCTEX_WINDOWS)
-		last_component = PathFindFileName(string);
-		last_extension = PathFindExtension(string);
-		if(last_extension == NULL)return;
-		if(last_component == NULL)last_component = string;
-		if(last_extension>last_component){/* filter out paths like "my/dir/.hidden" */
-			last_extension[0] = '\0';
-		}
-#       else
 		char * next = NULL;
 		/*  first we find the last path component */
 		if(NULL == (last_component = strstr(string,"/"))){
@@ -183,12 +125,12 @@
 				last_component = next+1;
 			}
 		}
+#       if defined(SYNCTEX_WINDOWS) || defined(SYNCTEX_OS2)
+		/*  On Windows, the '\' is also a path separator. */
-#               if defined(SYNCTEX_OS2)
-		/*  On OS2, the '\' is also a path separator. */
 		while((next = strstr(last_component,"\\"))){
 			last_component = next+1;
 		}
+#       endif
-#               endif /* SYNCTEX_OS2 */
 		/*  then we find the last path extension */
 		if((last_extension = strstr(last_component,"."))){
 			++last_extension;
@@ -200,7 +142,6 @@
 				last_extension[0] = '\0';
 			}
 		}
-#       endif /* SYNCTEX_WINDOWS */
 	}
 }
 
@@ -209,7 +150,7 @@
     if (SYNCTEX_IS_DOT((*name_ref)[0]) && SYNCTEX_IS_PATH_SEPARATOR((*name_ref)[1])) {
         do {
             (*name_ref) += 2;
+            while (SYNCTEX_IS_PATH_SEPARATOR((*name_ref)[1])) {
-            while (SYNCTEX_IS_PATH_SEPARATOR((*name_ref)[0])) {
                 ++(*name_ref);
             }
         } while(SYNCTEX_IS_DOT((*name_ref)[0]) && SYNCTEX_IS_PATH_SEPARATOR((*name_ref)[1]));
@@ -298,8 +239,8 @@
 }
 
 int _synctex_copy_with_quoting_last_path_component(const char * src, char ** dest_ref, size_t size) {
+  const char * lpc;
   if(src && dest_ref) {
-      const char * lpc;
 #		define dest (*dest_ref)
 		dest = NULL;	/*	Default behavior: no change and sucess. */
 		lpc = _synctex_last_path_component(src);
@@ -444,6 +385,7 @@
 				if(NULL == (dir_name = (char *)malloc(size+1))) {
 					_synctex_error("!  _synctex_get_name: Memory problem");
 					free(core_name);
+					dir_name = NULL;
 					return -1;
 				}
 				if(dir_name != strncpy(dir_name,output,size)) {
@@ -544,17 +486,6 @@
 #			undef CLEAN_AND_REMOVE
             /* set up the returned values */
             * synctex_name_ref = synctex_name;
-            /* synctex_name won't always end in .gz, even when compressed. */
-            FILE * F = fopen(synctex_name, "r");
-            if (F != NULL) {
-                if (!feof(F)
-                && 31 == fgetc(F)
-                && !feof(F)
-                && 139 == fgetc(F)) {
-                    io_mode = synctex_compress_mode_gz;
-                }
-                fclose(F);
-            }
             * io_mode_ref = io_mode;
 			return 0;
 		}
--- b/cut-n-paste/synctex/synctex_parser_utils.h
+++ a/cut-n-paste/synctex/synctex_parser_utils.h
@@ -1,15 +1,16 @@
 /* 
+Copyright (c) 2008, 2009, 2010, 2011 jerome DOT laurens AT u-bourgogne DOT fr
- Copyright (c) 2008-2017 jerome DOT laurens AT u-bourgogne DOT fr
- 
- This file is part of the __SyncTeX__ package.
- 
- [//]: # (Latest Revision: Fri Jul 14 16:20:41 UTC 2017)
- [//]: # (Version: 1.21)
- 
- See `synctex_parser_readme.md` for more details
- 
- ## License
 
+This file is part of the SyncTeX package.
+
+Latest Revision: Tue Jun 14 08:23:30 UTC 2011
+
+Version: 1.17
+
+See synctex_parser_readme.txt for more details
+
+License:
+--------
 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the "Software"), to deal in the Software without
@@ -38,22 +39,16 @@
 
 */
 
-#ifndef SYNCTEX_PARSER_UTILS_H
-#define SYNCTEX_PARSER_UTILS_H
-
 /*  The utilities declared here are subject to conditional implementation.
  *  All the operating system special stuff goes here.
  *  The problem mainly comes from file name management: path separator, encoding...
  */
 
+#	define synctex_bool_t int
+#	define synctex_YES -1
-#include "synctex_version.h"
-
-typedef int synctex_bool_t;
-#	define synctex_YES (0==0)
-#	define synctex_NO (0==1)
-
 #	define synctex_ADD_QUOTES -1
 #	define synctex_COMPRESS -1
+#	define synctex_NO 0
 #	define synctex_DONT_ADD_QUOTES 0
 #	define synctex_DONT_COMPRESS 0
 
@@ -90,15 +85,10 @@
  *  There is no bzero function on windows. */
 void *_synctex_malloc(size_t size);
 
-/*  To balance _synctex_malloc.
- *  ptr might be NULL.   */
-void _synctex_free(void * ptr);
-
 /*  This is used to log some informational message to the standard error stream.
  *  On Windows, the stderr stream is not exposed and another method is used.
  *	The return value is the number of characters printed.	*/
+int _synctex_error(const char * reason,...);
-    int _synctex_error(const char * reason,...);
-    int _synctex_debug(const char * reason,...);
 
 /*  strip the last extension of the given string, this string is modified!
  *  This function depends on the OS because the path separator may differ.
@@ -160,4 +150,3 @@
 #endif
 
 #endif
-#endif /* SYNCTEX_PARSER_UTILS_H */
--- b/libdocument/ev-document.c
+++ a/libdocument/ev-document.c
@@ -64,7 +64,7 @@
 	EvPageSize     *page_sizes;
 	EvDocumentInfo *info;
 
+	synctex_scanner_t synctex_scanner;
-	synctex_scanner_p synctex_scanner;
 };
 
 static guint64         _ev_document_get_size_gfile  (GFile      *file);
@@ -640,7 +640,7 @@
                                      gfloat      y)
 {
         EvSourceLink *result = NULL;
+        synctex_scanner_t scanner;
-        synctex_scanner_p scanner;
 
         g_return_val_if_fail (EV_IS_DOCUMENT (document), NULL);
 
@@ -649,10 +649,10 @@
                 return NULL;
 
         if (synctex_edit_query (scanner, page_index + 1, x, y) > 0) {
+                synctex_node_t node;
-                synctex_node_p node;
 
                 /* We assume that a backward search returns either zero or one result_node */
+                node = synctex_next_result (scanner);
-                node = synctex_scanner_next_result (scanner);
                 if (node != NULL) {
 			const gchar *filename;
 
@@ -675,8 +675,7 @@
  * @source_link: a #EvSourceLink
  *
  * Peforms a Synctex forward search to obtain the area in the document
+ * corresponding to the position @line and @column number in the source Tex file
- * corresponding to the position (line and column in @source_link) in
- * the source Tex file.
  *
  * Returns: An EvMapping with the page number and area corresponfing to
  * the given line in the source file. It must be free with g_free when done
@@ -686,7 +685,7 @@
 				    EvSourceLink *link)
 {
         EvMapping        *result = NULL;
+        synctex_scanner_t scanner;
-        synctex_scanner_p scanner;
 
         g_return_val_if_fail (EV_IS_DOCUMENT (document), NULL);
 
@@ -694,16 +693,11 @@
         if (!scanner)
                 return NULL;
 
+        if (synctex_display_query (scanner, link->filename, link->line, link->col) > 0) {
+                synctex_node_t node;
-	/* Since 1.19, synctex_display_query has a fourth parameter,
-	 * page-hint, which we set into a dummy number to not break the
-	 * API. In synctex it is used to set the best results first
-	 * given the page-hint
-	 */
-        if (synctex_display_query (scanner, link->filename, link->line, link->col, 0) > 0) {
-                synctex_node_p node;
                 gint           page;
 
+                if ((node = synctex_next_result (scanner))) {
-                if ((node = synctex_scanner_next_result (scanner))) {
                         result = g_new (EvMapping, 1);
 
                         page = synctex_node_page (node) - 1;
